import sys
import utility_integration as util
sys.path.append("../../../../tests")

class test_administration_admin_system(util.WrapTest):
    
    def test_administration_admin_system_base_functionality(self):
        base_url = "/system/administration/system/config"
        device = util.Env().device
        with self.subTest("multiple_get"):
            x = self.get(base_url)
            x.assert_data([{
                ".type":"system",
                "hostname":"Teltonika-" + device + ".com",
                "id":"general",
                "routername":device
            }])
        with self.subTest("single_get"):
            x = self.get(base_url + "/general")
            x.assert_data({
                ".type":"system",
                "hostname":"Teltonika-" + device + ".com",
                "id":"general",
                "routername":device
            })
        with self.subTest("configure_administration_admin_system"):
            x = self.put_data(base_url + "/general", {
                "hostname":"test.com",
                "routername":"integrationTest"
            })
            x.assert_data({
                ".type":"system",
                "hostname":"test.com",
                "routername":"integrationTest",
                "id":"general"
            })
        with self.subTest("get_configured"):
            x = self.get(base_url + "/general")
            x.assert_data({
                ".type":"system",
                "hostname":"test.com",
                "routername":"integrationTest",
                "id":"general"
            })
        with self.subTest("return_configuration"):
            x = self.put_data(base_url + "/general", {
                "hostname":"Teltonika-" + device + ".com",
                "routername":device
            })
            x.assert_data({
                ".type":"system",
                "hostname":"Teltonika-" + device + ".com",
                "id":"general",
                "routername":device
            })
        
    def test_administration_admin_system_deletion(self):
        x = self.delete("/system/administration/system/config")
        x.assert_error("Validation", "Section deletion is not allowed", 111, None, None)
    def test_administration_admin_system_creation(self):
        x = self.post_data("/system/administration/system/config", {})
        x.assert_error("Validation", "Section creation is not allowed", 108, None, None)