import sys
import utility_integration as util
sys.path.append("../../../../tests")

class test_administration_scripts(util.WrapTest):

    def test_administration_uscripts_base_functionality(self):
        base_url = "/system/administration/uscripts/config"
        with self.subTest("get"):
            x = self.get(base_url)
            x.assert_data({
                "script":"# Put your custom commands here that should be executed once\n# the system init finished. By default this file does nothing.\n\nexit 0\n"
            })
        with self.subTest("update_script"):
            x = self.send_file(base_url, "files/custom_script_edited")
            x.assert_data({
                "path":"/etc/rc.local"
            })
        with self.subTest("get_updated"):
            x = self.get(base_url)
            x.assert_data({
                "script":"# Put your custom commands here that should be executed once\n# the system init finished. By default this file does nothing.\n\nexit 0\nedited"
            })
        with self.subTest("return_changes"):
            x  = self.send_file(base_url, "files/custom_script_original")
            x.assert_data({
                "path":"/etc/rc.local"
            })
        with self.subTest("get_original"):
            x = self.get(base_url)
            x.assert_data({
                "script":"# Put your custom commands here that should be executed once\n# the system init finished. By default this file does nothing.\n\nexit 0\n"
            })