import sys
sys.path.append("../../../../tests")
import utility_integration as util

class test_auto_reboot(util.WrapTest):

	def test_periodic_reboot_base_functionality(self):
		endpoint = "/services/auto_reboot/periodic/config"
		x = self.post(endpoint, {"data": {"enable": "1"}})
		section_id = x.resp.json()['data']['id']
		x.assert_data({".type": "reboot_instance", "enable": "1", "id": section_id}, 201)
		x = self.put(endpoint+"/"+section_id, {"data": {"enable": "0", "action": "1", "period": "week", "days": ["mon"]}})
		x.assert_data({".type": "reboot_instance", "enable": "0", "action": "1", "period": "week", "days": ["mon"], "id": section_id})
		x = self.delete(endpoint+"/"+section_id)
		x.assert_data({
			"id": section_id
		})

	def test_ping_reboot_base_functionality(self):
		endpoint = "/services/auto_reboot/ping/config"
		x = self.post(endpoint, {"data": {"enable": "0", "type": "ping", "action": "1", "interface": "1", "ip_type": "ipv4", "host": "8.8.8.8"}})
		section_id = x.resp.json()['data']['id']
		x.assert_data({".type": "ping_reboot", "enable": "0", "action": "1", "host": "8.8.8.8", "interface": "1", "ip_type": "ipv4", "packet_size": "56", "retry": "2", "time_out": "10", "type": "ping", "id": section_id}, 201)
		x = self.put(endpoint+"/"+section_id, {"data": {"enable": "0", "action": "1", "host": "1.1.1.1"}})
		x.assert_data({".type": "ping_reboot", "enable": "0", "action": "1", "host": "1.1.1.1", "interface": "1", "ip_type": "ipv4", "packet_size": "56", "retry": "2", "time_out": "10", "type": "ping", "id": section_id})
		x = self.delete(endpoint+"/"+section_id)
		x.assert_data({
			"id": section_id
		})