import sys
import utility_integration as util
import response_codes as codes
sys.path.append("../../../../tests")
Env = util.Env
from utils.ssh import get_ssh

class system(util.WrapTest):
    ssh = get_ssh()

    def test_system_base_functionality(self):
        base_url = "/system/base"
        with self.subTest("change_firstlogin_option"):
            self.ssh.send_cmd("uci set vuci.main.firstlogin=1")
            self.ssh.send_cmd("uci commit vuci")
        with self.subTest("change_password_firstlogin"):
            x = self.post_data(base_url + "/actions/change_password_firstlogin", {
                "password":Env.password,
                "password_confirm":Env.password
            })
            x.assert_data({
                "response":"ok"
            })
        with self.subTest("try_change_again"):
            x = self.post_data(base_url + "/actions/change_password_firstlogin", {
                "password":Env.password,
                "password_confirm":Env.password
            })
            x.assert_error("Request", "First login is already done.", codes.ResponseCodes.INCORRECT_REQUEST.val())