import sys
sys.path.append("../../../../tests")
from utility_integration import WrapTest, Env
from utils.ssh import open_ssh_connection, is_process_running
from time import sleep

class Cumulocity(WrapTest):
    cumulocity_url = "/services/cloud_solutions/cumulocity/config/general"
    cot_url = "/services/cloud_solutions/cot/config/general"
    
    cumulocity_data = {
        "enabled": "0",
        ".type": "iot",
        "interval": "69",
        "id": "general",
        "ssl": "1",
        "server": "test.com"
    }

    cot_data = {
        "enabled": "0",
        ".type": "iot",
        "interval": "69",
        "id": "general",
        "server": "test.com"
    }

    def test_cumulocity_update(self):
        x = self.put_data(self.cumulocity_url, self.cumulocity_data)
        x.assert_data(self.cumulocity_data, 200)


    def test_cot_update(self):
        x = self.put_data(self.cot_url, self.cot_data)
        x.assert_data(self.cot_data, 200)

    def test_check_process(self):
        with open_ssh_connection() as ssh:
            self.assertFalse(is_process_running(ssh, "cmStreamApp"), "Expected 'cmStreamApp' not to be running")

            self.cumulocity_data["enabled"] = "1"
            self.put_data(self.cumulocity_url, self.cumulocity_data)

            self.assertTrue(is_process_running(ssh, "cmStreamApp"), "Expected 'cmStreamApp' to be running")

            self.cumulocity_data["enabled"] = "0"
            self.put_data(self.cumulocity_url, self.cumulocity_data)

            