import sys
sys.path.append("../../../../tests")
from utility_integration import WrapTest, Env
import response_codes as codes
from utils.ssh import open_ssh_connection, send_cmd
import json
import operator

RC = codes.ResponseCodes

def dateSort(x):
    return x['date']

class ReadMessages(WrapTest):
    url_get_message = "/services/mobile_utilities/sms_messages/read/config"
    modems = []

    def test_get_message(self):
        x = self.get(self.url_get_message)
        x.assert_code(200)
        sms_respone = x.resp.json()["data"]
        message_from_ubus = []
        if len(sms_respone) >= 1:
            with open_ssh_connection() as ssh:
                if len(self.modems) == 0:
                    available_modems = send_cmd(ssh, "ubus list gsm.modem*")
                    for available_modem in available_modems.splitlines():
                        self.modems.append({
                            "gsm": available_modem,
                            "modem_id": json.loads(send_cmd(ssh, "ubus call " + available_modem + " info"))["usb_id"]    
                        })

                with self.subTest("test with all messages"):
                    for modem in self.modems:
                        messages = json.loads(send_cmd(ssh, "ubus call " + modem["gsm"] + " read_sms \'{\"index\": -1}\' ").strip())["messages"]
                        for message in messages:
                            message_from_ubus.append({
                                "id": str(message["index"]),
                                "date": message["date"],
                                "sender": message["sender"],
                                "message": message["text"],
                                "status": message["stat_id_str"],
                                "modem_id": modem["modem_id"]
                            })
                    sms_respone.sort(key=dateSort)
                    message_from_ubus.sort(key=dateSort)
                    self.assertListEqual(sms_respone, message_from_ubus)

                with self.subTest("test with single message"):
                    for modem in self.modems:
                        messages = json.loads(send_cmd(ssh, "ubus call " + modem["gsm"] + " read_sms \'{\"index\": -1}\' ").strip())["messages"]
                        if len(messages) > 0: 
                            x = self.get(f"{self.url_get_message}/{modem['modem_id']}/{str(messages[0]['index'])}")
                            x.assert_data({
                                "id": str(messages[0]["index"]),
                                "date": messages[0]["date"],
                                "sender": messages[0]["sender"],
                                "message": messages[0]["text"],
                                "status": messages[0]["stat_id_str"],
                                "modem_id": modem["modem_id"]
                            })

    def test_delete_sms(self):
        x = self.get(self.url_get_message)
        x.assert_code(200)
        sms_respone = x.resp.json()["data"]
        
        if len(sms_respone) == 0:
            self.skipTest("None message to delete")

        x = self.delete((self.url_get_message + "/" + sms_respone[0]["modem_id"]+ "/" + sms_respone[0]["id"]))
        x.assert_code(200)