from response_codes import ResponseCodes
import utility_integration as util
import sys
sys.path.append("../../../../tests")
BASE_URL = "/services/ntpd/config"
NTP_SERVER_URL = "/services/ntp/server/config/general"
AVAILABLE_OPTS = {"enabled": "",
                  "file_flag": "",
                  "config_file": "",
                  "server": "",
                  "enable_server": ""}


class test_ntpd(util.WrapTest):
    def test_ntpd_enabled_validation(self):
        default_cfg = None
        with self.subTest("get ntpd cfg"):
            x = self.get(BASE_URL + "/general")
            x.assert_code(200)
            default_cfg = x.json["data"]
            for opt in AVAILABLE_OPTS:
                default_cfg[opt] = default_cfg.get(opt) or ""

        with self.subTest("disable ntpd"):
            x = self.put_data(BASE_URL + "/general", {"enabled": "0"})
            x.assert_code(200)

        with self.subTest("main test"):
            ntp_serv_enabled = None
            with self.subTest("enable ntp server"):
                x = self.get(NTP_SERVER_URL)
                ntp_serv_enabled = x.json["data"]["enabled"]
                if ntp_serv_enabled != "1":
                    x = self.put_data(NTP_SERVER_URL, {"enabled": "1"})
                    x.assert_code(200)

            with self.subTest("test ntpd enabled validation"):
                x = self.put_data(BASE_URL + "/general", {"enabled": "1"})
                x.assert_code(422)

            with self.subTest("disable ntp server"):
                x = self.put_data(NTP_SERVER_URL, {"enabled": "0"})
                x.assert_code(200)

            with self.subTest("test ntpd enabled validation"):
                x = self.put_data(BASE_URL + "/general", {"enabled": "1"})
                x.assert_code(200)

            with self.subTest("reset ntp server cfg"):
                x = self.put_data(NTP_SERVER_URL, {"enabled": ntp_serv_enabled or ""})
                x.assert_code(200)

        with self.subTest("reset ntpd cfg"):
            x = self.put_data(BASE_URL + "/general", default_cfg)
            x.assert_code(200)

    def test_ntpd_deletion(self):
        x = self.delete(BASE_URL + "/general")
        x.assert_error("Validation", "Section deletion is not allowed", ResponseCodes.NO_DELETE.val())

    def test_ntpd_creation(self):
        x = self.post_data(BASE_URL, {})
        x.assert_error("Validation", "Section creation is not allowed", ResponseCodes.NO_CREATE.val())
