import response_codes as codes
import utility_integration as util
import sys

sys.path.append("../../../../tests")


class test_phone_groups(util.WrapTest):
    def test_phone_groups_base_functionality(self):
        base_url = "/system/recipients/phone_groups/config"
        id = ""
        with self.subTest("create_section"):

            x = self.post_data(base_url, {
                "name": "testPhone",
                "tel": ["+37068539999", "+37068539998", "+37068539997"]
            })
            x.assert_data({
                ".type": "phone",
                "name": "testPhone",
                "tel": ["+37068539999", "+37068539998", "+37068539997"]
            }, 201, ["id"])
        with self.subTest("find_section_id"):
            x = self.get(base_url)
            resp = x.resp
            found = False
            for section in resp.json()["data"]:
                if section["name"] == "testPhone":
                    found = True
                    id = section["id"]
            if not found:
                self.fail("Section is not created")
        with self.subTest("configure_section"):
            x = self.put_data(base_url + "/" + id, {
                "tel": ["+37061123333", "+37061124444"]
            })
            x.assert_data({
                ".type": "phone",
                "name": "testPhone",
                "tel": ["+37061123333", "+37061124444"],
                "id": id
            })
        with self.subTest("get_section"):
            x = self.get(base_url + "/" + id)
            x.assert_data({
                ".type": "phone",
                "name": "testPhone",
                "tel": ["+37061123333", "+37061124444"],
                "id": id
            })
        with self.subTest("delete_section"):
            x = self.delete(base_url + "/" + id)
            x.assert_data({
                "id": id
            })
