import sys
sys.path.append("../../../../tests")
from utility_integration import WrapTest, Env

class test_snmp_communities(WrapTest):
    url_communities = "/services/snmp/communities/config"
    url_communities_v6 = "/services/snmp/communities_v6/config"

    def test_basic_update_communities(self):
        x = self.get(self.url_communities)
        x.assert_code(200)
        sid = x.resp.json()["data"][0]["id"]

        x = self.put_data(f"{self.url_communities}/{sid}", {
            "ipaddr": "1.1.1.1",
            "netmask": "24",
            "secname": "rw",
            "community": "test"
        })
        x.assert_data({
            ".type": "com2sec",
            "ipaddr": "1.1.1.1",
            "community": "test",
            "secname": "rw",
            "id": sid,
            "netmask": "24"
        })

    def test_basic_update_communities_v6(self):
        x = self.get(self.url_communities_v6)
        x.assert_code(200)
        sid = x.resp.json()["data"][0]["id"]

        x = self.put_data(f"{self.url_communities_v6}/{sid}", {
            "secname": "rw",
            "source": "defaultv1",
            "community": "test"
        })
        x.assert_data({
            ".type": "com2sec6",
            "source": "defaultv1",
            "community": "test",
            "secname": "rw",
            "id": sid
        })