import sys
sys.path.append("../../../../tests")
from utility_integration import WrapTest, Env
import utility_integration as util
from utils.ssh import open_ssh_connection

http = util.Env.http
api_url = util.Env.get_api_url()

class test_snmp_system(WrapTest):
    url_settings = "/services/snmp/system/config/general"
    url_mib = "/services/snmp/system/files/mib"

    def test_basic_update_snmp_system(self):
        x = self.put_data(self.url_settings, {
            "sysLocation": "test420",
            "sysContact": "test@test.com",
            "sysName": "test420"
        })
        x.assert_data({
            ".type": "system",
            "id": "general",
            "oid": "1.3.6.1.4.1.48690",
            "sysLocation": "test420",
            "sysContact": "test@test.com",
            "sysName": "test420"
        })

    def test_basic_update_snmp_mib_file(self):
        mib_from_api = http.request("get",api_url + self.url_mib).content
        mib_from_api = mib_from_api.decode("utf-8") 
        mib_from_api = mib_from_api.replace("\r", "")

        file_path = self.get_section("snmpd", "general")["values"]["mibfile"]

        with open_ssh_connection() as ssh:
            mib_from_device = ssh.send_cmd(f"cat {file_path}")
            mib_from_device = mib_from_device.replace("\r", "")
            
            self.assertEqual(mib_from_api, mib_from_device)