import utility_integration as util
import sys

sys.path.append("../../../../tests")


class test_snmp_trap_settings(util.WrapTest):
    BASE_URL = "/services/snmp/trap_settings/config"

    def test_snmp_trap_settings_default_section_creation(self):

        original_section = None

        def check_section():
            x = self.get(self.BASE_URL + "/general")
            x.assert_code(200)
            section = x.resp.json()["data"]
            self.assertGreater(len(section), 0)
            return section

        with self.subTest("check_original_section"):
            original_section = check_section()

        with self.subTest("delete_original_section"):
            self.delete_section("snmptrap", "@server[0]")

        with self.subTest("check_created_section"):
            check_section()

        with self.subTest("restore_original_section"):
            if "id" in original_section:
                del original_section["id"]
            x = self.put_data(self.BASE_URL + "/general", original_section)
            x.assert_code(200)

    def test_basic_update_trap_settings(self):
        x = self.put_data(f"{self.BASE_URL}/general", {
            "enabled": "0",
            "host": "test1.com",
            "port": "410",
            "community": "testtest"
        })
        x.assert_data({
            "enabled": "0",
            "port": "410",
            "community": "testtest",
            "id": "general",
            ".type": "server",
            "host": "test1.com"
        }, 200)