import sys
sys.path.append("../../../../tests")
from utility_integration import WrapTest, Env
import response_codes as codes

RC = codes.ResponseCodes

class test_snmp_communities(WrapTest):
    url_v3 = "/services/snmp/v3/config"

    def test_basic_crud(self):
        self.crud_test(self.url_v3, {
            "authtype": "SHA",
            ".type": "user",
            "username": "blatata",
            "mibaccess": "test",
            "privpass": "testastt",
            "enabled": "0",
            "authpass": "assdavvv",
            "seclevel": "auth",
            "rights": "ro",
            "privtype": "DES"
        },
        {
            "username": "blatata",
            "authtype": "MD5",
            ".type": "user",
            "mibaccess": "test",
            "privpass": "testastt",
            "enabled": "0",
            "authpass": "assdavvv",
            "seclevel": "priv",
            "rights": "rw",
            "privtype": "AES"
        })

    def test_common_username(self):
        x = self.post_data(self.url_v3,{
            "username": "blatataratata"
        })
        x.assert_code(201)
        sid = x.resp.json()["data"]["id"]
        x = self.post_data(self.url_v3,{
            "username": "blatataratata"
        })
        x.assert_error("username", "User 'blatataratata' already exists", RC.INVALID_OPT.val())

        x = self.delete(f"{self.url_v3}/{sid}")
        x.assert_data({
            "id": sid
        })
        