import sys
import utility_integration as util
import response_codes as codes
from utils.ssh import open_ssh_connection, send_cmd
sys.path.append("../../../../tests")

class troubleshoot_diagnostics(util.WrapTest):

    def test_troubleshoot_diagnostics_base_functionality(self):
        base_url = "/system/diagnostics"
        internet_connection = False
        with self.subTest("check_internet_connection"):
            with open_ssh_connection() as ssh:
                res = send_cmd(ssh, "ping -c 1 1.1.1.1 &> /dev/null ; echo $?")
                internet_connection = res.strip() == "0"
        if internet_connection:
            with self.subTest("ping"):
                x = self.post_data(base_url + "/actions/ping", {
                    "host":"8.8.8.8",
                    "proto":"ipv4"
                })
                x.assert_code(200)
        else:
            with self.subTest("ping_no_connection"):
                x = self.post_data(base_url + "/actions/ping", {
                    "host":"8.8.8.8",
                    "proto":"ipv4"
                })
                x.assert_data({
                    "response":"PING 8.8.8.8 (8.8.8.8): 56 data bytes\nping: sendto: Network unreachable\n"
                })