/**
 * Copyright 2013-2020 Automatak, LLC
 *
 * Licensed to Green Energy Corp (www.greenenergycorp.com) and Automatak
 * LLC (www.automatak.com) under one or more contributor license agreements.
 * See the NOTICE file distributed with this work for additional information
 * regarding copyright ownership. Green Energy Corp and Automatak LLC license
 * this file to you under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License. You may obtain
 * a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.automatak.render.dnp3.objects

/*
Common variation names
 */
object VariationNames {
  val anyVariation = "Any Variation"
  val packedFormat = "Packed Format"
  val withFlags = "With Flags"
  val withTime = "With Time"
  val withoutTime = "Without Time"
  val withAbsoluteTime = "With Absolute Time"
  val withRelativeTime = "With Relative Time"
  val outputStatusWithFlags = "Output Status With Flags"
  val outputStatusWithTime = "Output Status With Time"
  val outputStatusWithoutTime = "Output Status Without Time"
  val crob = "CROB"
  val bit32 = "32-bit"
  val bit16 = "16-bit"
  val bit32WithTime = "32-bit With Time"
  val bit16WithTime = "16-bit With Time"
  val bit32WithFlag = "32-bit With Flag"
  val bit16WithFlag = "16-bit With Flag"
  val bit32WithoutFlag = "32-bit Without Flag"
  val bit16WithoutFlag = "16-bit Without Flag"
  val bit32WithFlagTime = "32-bit With Flag and Time"
  val bit16WithFlagTime = "16-bit With Flag and Time"
  val singlePrecision = "Single-precision"
  val doublePrecision = "Double-precision"
  val singlePrecisionWithTime = "Single-precision With Time"
  val doublePrecisionWithTime = "Double-precision With Time"
  val singlePrecisionWithFlag = "Single-precision With Flag"
  val doublePrecisionWithFlag = "Double-precision With Flag"
  val singlePrecisionWithFlagTime = "Single-precision With Flag and Time"
  val doublePrecisionWithFlagTime = "Double-precision With Flag and Time"
}
