#include <twTls.h>
#include "twApi.h"
#include "TestUtilities.h"
#include "unity.h"
#include "unity_fixture.h"
#include "unitTestDefs.h"
#include "twApiStubs.h"

TEST_GROUP(unit_twCodeToString);

TEST_SETUP(unit_twCodeToString) {
	eatLogs();
}

TEST_TEAR_DOWN(unit_twCodeToString) {
	twStubs_Reset();
}

TEST_GROUP_RUNNER(unit_twCodeToString) {
	RUN_TEST_CASE(unit_twCodeToString, test_twLogger_twCodeToString);
}

extern twApi *tw_api;

TEST(unit_twCodeToString, test_twLogger_twCodeToString) {
	TEST_ASSERT_EQUAL_STRING("GET", twCodeToString(TWX_GET));
	TEST_ASSERT_EQUAL_STRING("PUT", twCodeToString(TWX_PUT));
	TEST_ASSERT_EQUAL_STRING("POST", twCodeToString(TWX_POST));
	TEST_ASSERT_EQUAL_STRING("DEL", twCodeToString(TWX_DEL));
	TEST_ASSERT_EQUAL_STRING("BIND", twCodeToString(TWX_BIND));
	TEST_ASSERT_EQUAL_STRING("UNBIND", twCodeToString(TWX_UNBIND));
	TEST_ASSERT_EQUAL_STRING("AUTH", twCodeToString(TWX_AUTH));
	TEST_ASSERT_EQUAL_STRING("KEEP_ALIVE", twCodeToString(TWX_KEEP_ALIVE));
	TEST_ASSERT_EQUAL_STRING("SUCCESS", twCodeToString(TWX_SUCCESS));
	TEST_ASSERT_EQUAL_STRING("BAD_REQUEST", twCodeToString(TWX_BAD_REQUEST));
	TEST_ASSERT_EQUAL_STRING("UNAUTHORIZED", twCodeToString(TWX_UNAUTHORIZED));
	TEST_ASSERT_EQUAL_STRING("BAD_OPTION", twCodeToString(TWX_BAD_OPTION));
	TEST_ASSERT_EQUAL_STRING("FORBIDDEN", twCodeToString(TWX_FORBIDDEN));
	TEST_ASSERT_EQUAL_STRING("NOT_FOUND", twCodeToString(TWX_NOT_FOUND));
	TEST_ASSERT_EQUAL_STRING("METHOD_NOT_ALLOWED", twCodeToString(TWX_METHOD_NOT_ALLOWED));
	TEST_ASSERT_EQUAL_STRING("NOT_ACCEPTABLE", twCodeToString(TWX_NOT_ACCEPTABLE));
	TEST_ASSERT_EQUAL_STRING("PRECONDITION_FAILED", twCodeToString(TWX_PRECONDITION_FAILED));
	TEST_ASSERT_EQUAL_STRING("ENTITY_TOO_LARGE", twCodeToString(TWX_ENTITY_TOO_LARGE));
	TEST_ASSERT_EQUAL_STRING("UNSUPPORTED_CONTENT_FORMAT", twCodeToString(TWX_UNSUPPORTED_CONTENT_FORMAT));
	TEST_ASSERT_EQUAL_STRING("INTERNAL_SERVER_ERROR", twCodeToString(TWX_INTERNAL_SERVER_ERROR));
	TEST_ASSERT_EQUAL_STRING("NOT_IMPLEMENTED", twCodeToString(TWX_NOT_IMPLEMENTED));
	TEST_ASSERT_EQUAL_STRING("BAD_GATEWAY", twCodeToString(TWX_BAD_GATEWAY));
	TEST_ASSERT_EQUAL_STRING("SERVICE_UNAVAILABLE", twCodeToString(TWX_SERVICE_UNAVAILABLE));
	TEST_ASSERT_EQUAL_STRING("GATEWAY_TIMEOUT", twCodeToString(TWX_GATEWAY_TIMEOUT));
	TEST_ASSERT_EQUAL_STRING("UNKNOWN", twCodeToString(-1));
}